tests.sh: less hackish way to handle fixme directories for savdirs
[nit.git] / tests / tests.sh
1 #!/bin/bash
2 # This file is part of NIT ( http://www.nitlanguage.org ).
3 #
4 # Copyright 2004-2008 Jean Privat <jean@pryen.org>
5 #
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not use this file except in compliance with the License.
8 # You may obtain a copy of the License at
9 #
10 # http://www.apache.org/licenses/LICENSE-2.0
11 #
12 # Unless required by applicable law or agreed to in writing, software
13 # distributed under the License is distributed on an "AS IS" BASIS,
14 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15 # See the License for the specific language governing permissions and
16 # limitations under the License.
17
18 # This shell script compile, run and verify Nit program files
19
20 # Set lang do default to avoid failed tests because of locale
21 export LANG=C
22 export NIT_TESTING=true
23
24 unset NIT_DIR
25
26 # Get the first Java lib available
27 shopt -s nullglob
28 paths=`echo /usr/lib/jvm/*/`
29 paths=($paths)
30 JAVA_HOME=${paths[0]}
31
32 paths=`echo $JAVA_HOME/jre/lib/*/{client,server}/`
33 paths=($paths)
34 JNI_LIB_PATH=${paths[0]}
35 shopt -u nullglob
36
37 usage()
38 {
39 e=`basename "$0"`
40 cat<<END
41 Usage: $e [options] modulenames
42 -o option Pass option to the engine
43 -v Verbose (show tests steps)
44 -h This help
45 --engine Use a specific engine (default=nitg)
46 --noskip Do not skip a test even if the .skip file matches
47 --[no]soso Force enable (or disable) SOSO
48 END
49 }
50
51 # $1 is the pattern of the test
52 # $2 is the file to compare to
53 # the result is:
54 # 0: if the file to compare to do not exists
55 # 1: if the file match
56 # 2: if the file match with soso
57 # 3: if the file do not match
58 function compare_to_result()
59 {
60 local pattern="$1"
61 local sav="$2"
62 if [ ! -r "$sav" ]; then return 0; fi
63 diff -u "$sav" "out/$pattern.res" > "out/$pattern.diff.sav.log"
64 if [ "$?" == 0 ]; then
65 return 1
66 fi
67 [ -z "$soso" ] && return 3
68 sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
69 sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
70 grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
71 grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
72 diff -u "out/$pattern.sav2" "out/$pattern.res2" > "out/$pattern.diff.sav.log"
73 if [ "$?" == 0 ]; then
74 return 2
75 else
76 return 3
77 fi
78 }
79
80 # As argument: the pattern used for the file
81 function process_result()
82 {
83 # Result
84 pattern=$1
85 description=$2
86 pack=$3
87 SAV=""
88 NSAV=""
89 FIXME=""
90 NFIXME=""
91 SOSO=""
92 NSOSO=""
93 SOSOF=""
94 NSOSOF=""
95 OLD=""
96 LIST=""
97 FIRST=""
98 echo >>$xml "<testcase classname='$pack' name='$description'>"
99 #for sav in "sav/$engine/fixme/$pattern.res" "sav/$engine/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
100 for savdir in $savdirs; do
101 sav=$savdir/fixme/$pattern.res
102 compare_to_result "$pattern" "$sav"
103 case "$?" in
104 0)
105 ;; # no file
106 1)
107 OLD="$LIST"
108 FIXME="$sav"
109 LIST="$LIST $sav"
110 ;;
111 2)
112 SOSOF="$sav"
113 LIST="$LIST $sav"
114 ;;
115 3)
116 if [ -z "$FIRST" ]; then
117 NFIXME="$sav"
118 FIRST="$sav"
119 fi
120 LIST="$LIST $sav"
121 ;;
122 esac
123
124 sav=$savdir/$pattern.res
125 compare_to_result "$pattern" "$sav"
126 case "$?" in
127 0)
128 ;; # no file
129 1)
130 OLD="$LIST"
131 SAV="$sav"
132 LIST="$LIST $sav"
133 ;;
134 2)
135 SOSO="$sav"
136 LIST="$LIST $sav"
137 ;;
138 3)
139 if [ -z "$FIRST" ]; then
140 NSAV="$sav"
141 FIRST="$sav"
142 fi
143 LIST="$LIST $sav"
144 ;;
145 esac
146 done
147 OLD=`echo "$OLD" | sed -e 's/ */ /g' -e 's/^ //' -e 's/ $//'`
148 grep 'NOT YET IMPLEMENTED' "out/$pattern.res" >/dev/null
149 NYI="$?"
150 if [ -n "$SAV" ]; then
151 if [ -n "$OLD" ]; then
152 echo "[*ok*] out/$pattern.res $SAV - but $OLD remains!"
153 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
154 remains="$remains $OLD"
155 else
156 echo "[ok] out/$pattern.res $SAV"
157 fi
158 ok="$ok $pattern"
159 elif [ -n "$FIXME" ]; then
160 if [ -n "$OLD" ]; then
161 echo "[*fixme*] out/$pattern.res $FIXME - but $OLD remains!"
162 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
163 remains="$remains $OLD"
164 else
165 echo "[fixme] out/$pattern.res $FIXME"
166 echo >>$xml "<skipped/>"
167 fi
168 todos="$todos $pattern"
169 elif [ -n "$SOSO" ]; then
170 echo "[soso] out/$pattern.res $SOSO"
171 ok="$ok $pattern"
172 elif [ "x$NYI" = "x0" ]; then
173 echo "[todo] out/$pattern.res -> not yet implemented"
174 echo >>$xml "<skipped/>"
175 todos="$todos $pattern"
176 elif [ -n "$SOSOF" ]; then
177 echo "[fixme soso] out/$pattern.res $SOSOF"
178 echo >>$xml "<skipped/>"
179 todos="$todos $pattern"
180 elif [ -n "$NSAV" ]; then
181 echo "[======= fail out/$pattern.res $NSAV =======]"
182 echo >>$xml "<error message='fail out/$pattern.res $NSAV'/>"
183 echo >>$xml "<system-out><![CDATA["
184 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
185 echo >>$xml "]]></system-out>"
186 nok="$nok $pattern"
187 echo "$ii" >> "$ERRLIST"
188 elif [ -n "$NFIXME" ]; then
189 echo "[======= changed out/$pattern.res $NFIXME ======]"
190 echo >>$xml "<error message='changed out/$pattern.res $NFIXME'/>"
191 echo >>$xml "<system-out><![CDATA["
192 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
193 echo >>$xml "]]></system-out>"
194 nok="$nok $pattern"
195 echo "$ii" >> "$ERRLIST"
196 elif [ -s out/$pattern.res ]; then
197 echo "[=== no sav ===] out/$pattern.res is not empty"
198 echo >>$xml "<error message='no sav and not empty'/>"
199 echo >>$xml "<system-out><![CDATA["
200 cat -v >>$xml out/$pattern.res
201 echo >>$xml "]]></system-out>"
202 nos="$nos $pattern"
203 else
204 # no sav but empty res
205 echo "[0k] out/$pattern.res is empty"
206 ok="$ok $pattern"
207 fi
208 if test -s out/$pattern.cmp.err; then
209 echo >>$xml "<system-err><![CDATA["
210 cat -v >>$xml out/$pattern.cmp.err
211 echo >>$xml "]]></system-err>"
212 fi
213 echo >>$xml "</testcase>"
214 }
215
216 need_skip()
217 {
218 test "$noskip" = true && return 1
219 if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
220 echo "=> $2: [skip]"
221 echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
222 return 0
223 fi
224 if test $engine = niti && echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
225 echo "=> $2: [skip exec]"
226 echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
227 return 0
228 fi
229 return 1
230 }
231
232 skip_exec()
233 {
234 test "$noskip" = true && return 1
235 if echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
236 echo -n "_ "
237 return 0
238 fi
239 return 1
240 }
241
242 skip_cc()
243 {
244 test "$noskip" = true && return 1
245 if echo "$1" | grep -f "cc.skip" >/dev/null 2>&1; then
246 return 0
247 fi
248 return 1
249 }
250
251 find_nitc()
252 {
253 name="$enginebinname"
254 recent=`ls -t ../src/$name ../src/$name_[0-9] ../bin/$name ../c_src/$name 2>/dev/null | head -1`
255 if [[ "x$recent" == "x" ]]; then
256 echo "Could not find binary for engine $engine, aborting"
257 exit 1
258 fi
259 echo "Find binary for engine $engine: $recent $OPT"
260 NITC=$recent
261 }
262
263 verbose=false
264 stop=false
265 engine=nitg
266 noskip=
267 savdirs=
268 while [ $stop = false ]; do
269 case $1 in
270 -o) OPT="$OPT $2"; shift; shift;;
271 -v) verbose=true; shift;;
272 -h) usage; exit;;
273 --engine) engine="$2"; shift; shift;;
274 --noskip) noskip=true; shift;;
275 --soso) soso=true; shift;;
276 --nososo) nososo=true; shift;;
277 *) stop=true
278 esac
279 done
280 enginebinname=$engine
281 case $engine in
282 nitg)
283 engine=nitg-s;
284 enginebinname=nitg;
285 OPT="--separate $OPT"
286 ;;
287 nitg-s)
288 enginebinname=nitg;
289 OPT="--separate $OPT"
290 ;;
291 nitg-e)
292 enginebinname=nitg;
293 OPT="--erasure $OPT"
294 ;;
295 nitg-g)
296 enginebinname=nitg;
297 OPT="--global $OPT"
298 ;;
299 nit)
300 engine=niti
301 ;;
302 niti)
303 enginebinname=nit
304 ;;
305 nitc)
306 echo "disabled engine $engine"
307 exit 0
308 ;;
309 *)
310 echo "unknown engine $engine"
311 exit 1
312 ;;
313 esac
314
315 savdirs="sav/$engine $savdirs sav/"
316
317 # The default nitc compiler
318 [ -z "$NITC" ] && find_nitc
319
320 # Set NIT_DIR if needed
321 [ -z "$NIT_DIR" ] && export NIT_DIR=..
322
323 if sh -c "timelimit echo" 1>/dev/null 2>&1; then
324 TIMEOUT="timelimit -t 600"
325 elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
326 TIMEOUT="timeout 600s"
327 else
328 echo "No timelimit or timeout command detected. Tests may hang :("
329 fi
330
331 # Mark to distinguish files among tests
332 # MARK=
333
334 # File where error tests are outputed
335 # Old ERRLIST is backuped
336 ERRLIST=${ERRLIST:-errlist}
337 ERRLIST_TARGET=$ERRLIST
338
339 if [ $# = 0 ]; then
340 usage;
341 exit
342 fi
343
344 # Initiate new ERRLIST
345 if [ "x$ERRLIST" = "x" ]; then
346 ERRLIST=/dev=null
347 else
348 ERRLIST=$ERRLIST.tmp
349 > "$ERRLIST"
350 fi
351
352 ok=""
353 nok=""
354 todos=""
355 xml="tests-$engine.xml"
356 echo >$xml "<testsuites><testsuite>"
357
358 # CLEAN the out directory
359 rm -rf out/ 2>/dev/null
360 mkdir out 2>/dev/null
361
362 for ii in "$@"; do
363 if [ ! -f $ii ]; then
364 echo "File '$ii' does not exist."
365 continue
366 fi
367 f=`basename "$ii" .nit`
368
369 pack=`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
370
371 # Sould we skip the file for this engine?
372 need_skip $f $f $pack && continue
373
374 tmp=${ii/../AA}
375 if [ "x$tmp" = "x$ii" ]; then
376 includes="-I . -I ../lib/standard -I ../lib/standard/collection -I alt"
377 else
378 includes="-I alt"
379 fi
380
381 for i in "$ii" `./alterner.pl --start '#' --altsep '_' $ii`; do
382 bf=`basename $i .nit`
383 ff="out/$bf"
384
385 # Sould we skip the alternative for this engine?
386 need_skip $bf $bf $pack && continue
387
388 echo -n "=> $bf: "
389
390 if [ -f "$f.inputs" ]; then
391 inputs="$f.inputs"
392 else
393 inputs=/dev/null
394 fi
395
396 if [ "$engine" = "niti" ]; then
397 cat > "./$ff.bin" <<END
398 exec $NITC --no-color $OPT "$i" $includes -- "\$@"
399 END
400 chmod +x "./$ff.bin"
401 > "$ff.cmp.err"
402 > "$ff.compile.log"
403 ERR=0
404 else
405 if skip_cc "$bf"; then
406 nocc="--no-cc"
407 else
408 nocc=
409 fi
410 # Compile
411 if [ "x$verbose" = "xtrue" ]; then
412 echo ""
413 echo $NITC --no-color $OPT -o "$ff.bin" "$i" "$includes" $nocc
414 fi
415 NIT_NO_STACK=1 JNI_LIB_PATH=$JNI_LIB_PATH JAVA_HOME=$JAVA_HOME \
416 $TIMEOUT $NITC --no-color $OPT -o "$ff.bin" "$i" $includes $nocc 2> "$ff.cmp.err" > "$ff.compile.log"
417 ERR=$?
418 if [ "x$verbose" = "xtrue" ]; then
419 cat "$ff.compile.log"
420 cat >&2 "$ff.cmp.err"
421 fi
422 fi
423 if [ "$ERR" != 0 ]; then
424 echo -n "! "
425 cat "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
426 process_result $bf $bf $pack
427 elif skip_exec "$bf"; then
428 # No exec
429 > "$ff.res"
430 process_result $bf $bf $pack
431 elif [ -n "$nocc" ]; then
432 # not compiled
433 echo -n "nocc "
434 > "$ff.res"
435 process_result $bf $bf $pack
436 elif [ -x "./$ff.bin" ]; then
437 echo -n ". "
438 # Execute
439 args=""
440 if [ "x$verbose" = "xtrue" ]; then
441 echo ""
442 echo "NIT_NO_STACK=1 ./$ff.bin" $args
443 fi
444 NIT_NO_STACK=1 LD_LIBRARY_PATH=$JNI_LIB_PATH \
445 $TIMEOUT "./$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
446 if [ "x$verbose" = "xtrue" ]; then
447 cat "$ff.res"
448 cat >&2 "$ff.err"
449 fi
450 if [ -f "$ff.write" ]; then
451 cat "$ff.write" >> "$ff.res"
452 elif [ -d "$ff.write" ]; then
453 LANG=C /bin/ls -F $ff.write >> "$ff.res"
454 fi
455 cp "$ff.res" "$ff.res2"
456 cat "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
457 process_result $bf $bf $pack
458
459 if [ -f "$f.args" ]; then
460 fargs=$f.args
461 cptr=0
462 while read line; do
463 ((cptr=cptr+1))
464 args="$line"
465 bff=$bf"_args"$cptr
466 fff=$ff"_args"$cptr
467 name="$bf args $cptr"
468
469 # Sould we skip the input for this engine?
470 need_skip $bff " $name" $pack && continue
471
472 # use a specific inputs file, if required
473 if [ -f "$bff.inputs" ]; then
474 ffinputs="$bff.inputs"
475 else
476 ffinputs=$inputs
477 fi
478
479 rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
480 if [ "x$verbose" = "xtrue" ]; then
481 echo ""
482 echo "NIT_NO_STACK=1 ./$ff.bin" $args
483 fi
484 echo -n "==> $name "
485 echo "./$ff.bin $args" > "./$fff.bin"
486 chmod +x "./$fff.bin"
487 WRITE="$fff.write" sh -c "NIT_NO_STACK=1 $TIMEOUT ./$fff.bin < $ffinputs > $fff.res 2>$fff.err"
488 if [ "x$verbose" = "xtrue" ]; then
489 cat "$fff.res"
490 cat >&2 "$fff.err"
491 fi
492 if [ -f "$fff.write" ]; then
493 cat "$fff.write" >> "$fff.res"
494 elif [ -d "$fff.write" ]; then
495 LANG=C /bin/ls -F $fff.write >> "$fff.res"
496 fi
497 if [ -s "$fff.err" ]; then
498 cp "$fff.res" "$fff.res2"
499 cat "$fff.err" "$fff.res2" > "$fff.res"
500 fi
501 process_result $bff " $name" $pack
502 done < $fargs
503 fi
504 elif [ -f "./$ff.bin" ]; then
505 echo "Not executable (platform?)" > "$ff.res"
506 process_result $bf "$bf" $pack
507 else
508 echo -n "! "
509 cat "$ff.cmp.err" > "$ff.res"
510 echo "Compilation error" > "$ff.res"
511 process_result $bf "$bf" $pack
512 fi
513 done
514 done
515
516 echo "engine: $engine ($enginebinname $OPT)"
517 echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
518
519 if [ -n "$nok" ]; then
520 echo "fail: $nok"
521 echo "There were $(echo $nok | wc -w) errors ! (see file $ERRLIST)"
522 fi
523 if [ -n "$nos" ]; then
524 echo "no sav: $nos"
525 fi
526 if [ -n "$todos" ]; then
527 echo "todo/fixme: $todos"
528 fi
529 if [ -n "$remains" ]; then
530 echo "sav that remains: $remains"
531 fi
532
533 # write $ERRLIST
534 if [ "x$ERRLIST" != "x" ]; then
535 if [ -x "$ERRLIST_TARGET" ]; then
536 mv "$ERRLIST_TARGET" "${ERRLIST_TARGET}.bak"
537 fi
538 mv $ERRLIST $ERRLIST_TARGET
539 fi
540
541 echo >>$xml "</testsuite></testsuites>"
542
543 if [ -n "$nok" ]; then
544 exit 1
545 else
546 exit 0
547 fi